﻿using Foundation;
using ObjCRuntime;
using UIKit;

namespace AdyenSDK
{
    [BaseType(typeof(NSObject), Name = "_TtC17Adyen_ios_binding7MyClass")]
    interface MyClass
    {
        // -(id)getValue __attribute__((warn_unused_result));
        [Export("getValue")]
        string Value { get; }
    }

    [BaseType(typeof(NSObject), Name = "_TtC17Adyen_ios_binding14PaymentManager")]
    // @interface PaymentManager
    interface PaymentManager
    {
        [Wrap("WeakDelegate")]
        [NullAllowed]
        PaymentManagerDelegate Delegate { get; set; }

        // @property (nonatomic, weak) id<PaymentManagerDelegate> _Nullable delegate;
        [NullAllowed, Export("delegate", ArgumentSemantic.Weak)]
        NSObject WeakDelegate { get; set; }

        // -(void)beginPaymentWithHostViewController:(UIViewController * _Nonnull)hostViewController;
        [Export("beginPaymentWithHostViewController:")]
        void BeginPaymentWithHostViewController(UIViewController hostViewController);

        // -(void)applicationDidOpenURL:(id)url;
        [Export("applicationDidOpenURL:")]
        void ApplicationDidOpenURL(NSObject url);
    }

    // @protocol PaymentManagerDelegate
    [Protocol, Model]
    [BaseType(typeof(NSObject), Name = "_TtP17Adyen_ios_binding22PaymentManagerDelegate_")]
    interface PaymentManagerDelegate
    {
        // @required -(void)paymentManager:(PaymentManager * _Nonnull)paymentManager didFinishWithResult:(PaymentManagerResult * _Nonnull)result;
        [Abstract]
        [Export("paymentManager:didFinishWithResult:")]
        void DidFinishWithResult(PaymentManager paymentManager, PaymentManagerResult result);
    }

    // @interface PaymentManagerResult
    [DisableDefaultCtor]
    [BaseType(typeof(NSObject), Name = "_TtC17Adyen_ios_binding20PaymentManagerResult")]
    interface PaymentManagerResult
    {
        // @property (readonly, nonatomic) enum PaymentManagerResultStatus status;
        [Export("status")]
        PaymentManagerResultStatus Status { get; }

        // @property (readonly, nonatomic) int * _Nullable error;
        [NullAllowed, Export("error")]
        int Error { get; }

        // +(instancetype _Nonnull)new __attribute__((deprecated("-init is unavailable")));
        [Static]
        [Export("new")]
        PaymentManagerResult New();
    }
}


